Imports Telerik.WinControls.Docking
Imports System.ComponentModel
Imports Telerik.WinControls

Partial Public Class Form1
    Private doSomethingItem1 As DockMenuItem
    Private doSomethingItem2 As DockMenuItem

    Public Sub New()
        InitializeComponent()

        AddHandler DockPanel1.DockContextMenu.DropDownOpening, AddressOf DockContextMenu_DropDownOpening
        AddHandler DockPanel2.DockContextMenu.DropDownOpening, AddressOf DockContextMenu_DropDownOpening
    End Sub

    Private Sub DockContextMenu_DropDownOpening(ByVal sender As Object, ByVal e As CancelEventArgs)
        Dim dockMenu As DockContextMenu = TryCast(sender, DockContextMenu)
        ' if the context menu invoker is dockPanel1
        If dockMenu.DockWindow Is DockPanel1 Then
            ' get the "Hide" item and hide it
            dockMenu.GetDefaultItem("Hide").Visibility = ElementVisibility.Collapsed

            If doSomethingItem1 Is Nothing Then
                doSomethingItem1 = New DockMenuItem(DockState.Floating, "Custom Item for DockPanel1")

                AddHandler doSomethingItem1.Click, AddressOf doSomethingItem1_Click
                dockMenu.Items.Add(doSomethingItem1)
            End If
            ' if the context menu invoker is dockPanel2
        ElseIf dockMenu.DockWindow Is DockPanel2 Then
            ' get the "Floating" item and hide it
            dockMenu.GetDefaultItem("Floating").Visibility = ElementVisibility.Collapsed

            If doSomethingItem2 Is Nothing Then
                doSomethingItem2 = New DockMenuItem(DockState.AutoHide, "Custom Item for DockPanel2")

                AddHandler doSomethingItem2.Click, AddressOf doSomethingItem2_Click
                dockMenu.Items.Add(doSomethingItem2)
            End If

            ' if the context menu invoker is a tabbed document
            If dockMenu.DockWindow.DockState = DockState.TabbedDocument Then
                doSomethingItem2.Visibility = ElementVisibility.Collapsed
            Else
                doSomethingItem2.Visibility = ElementVisibility.Visible
            End If
        End If
    End Sub

    Private Sub doSomethingItem2_Click(ByVal sender As Object, ByVal e As EventArgs)
        DockPanel2.DockState = (CType(sender, DockMenuItem)).DockState
        ' Do something here
    End Sub

    Private Sub doSomethingItem1_Click(ByVal sender As Object, ByVal e As EventArgs)
        DockPanel1.DockState = (CType(sender, DockMenuItem)).DockState
        ' Do something here
    End Sub
End Class